class CCompareDocuments
{
public:
	CCompareDocuments(int ndocuments);
	~CCompareDocuments();
	void CompareDocuments();
private:
	void DocumentToHtml(CInputDocument indoc, FILE *fhtmlp, int *match, int *matcha, long words, wchar_t href[255]);
	void HeapSort(unsigned long *tableA,int *tableB,int n);
	int PercentMatching(int firstL,int firstR,int lastL,int lastR,int perfectmatches);
	void printWCharAsHtmlUTF8(FILE *outputFile,wchar_t wc);
public:
	struct Document
	{
		wchar_t m_DocumentName[256];						// an entry for the document name
		unsigned long *m_pWordHash;					// a pointer to the hash-coded word list
		unsigned long *m_pSortedWordHash;					// a pointer to the sorted hash-coded word list
		int *m_pSortedWordNumber;								// a pointer to the sorted word number list
		int m_NumberOfWords;									// an entry for the number of words in the lists
		int m_FirstHash;								// an entry for the first word with more than 3 chars
	};

	struct Document (*m_pDocs);	// the pointer to all the documents
	struct Document (*m_pDocL); // pointer to the Left document
	struct Document (*m_pDocR); // pointer to the right documnet
	int m_Documents; // number of documents
private:
	FILE *m_fMatch;						// handle for comparisons that exceed threshold (output)
	FILE *m_fMatchHtml;					// handle for comparisons that exceed threshold (output) - html
	int *m_MatchL,*m_MatchR;					// left and right matched word markup list pointers
	int *m_MatchLa, *m_MatchRa;				// left and right matched string anchors for html files
	int *m_MatchLt,*m_MatchRt;				// left and right matched word  markup list pointers - temporary
	unsigned long *m_pQWordHash;			// a pointer to a working hash-coded word list
	unsigned long *m_pXWordHash;			// a pointer to a temporary hash-coded word list
public:
	int m_PhraseLength;
	int m_WordThreshold;
	int m_FirstNewDocument;
	CString* m_szFolder;
	CListCtrl* m_pReport;
	CStatic* m_pStatus;
	CProgressCtrl* m_pProgress;
	bool m_bIgnoreCase;
	bool m_bIgnoreNumbers;
	bool m_bIgnorePunctuation;
	bool m_bIgnoreOuterPunctuation;
	bool m_bSkipLongWords;
	bool m_bSkipNonwords;
	unsigned int m_SkipLength;
	int m_MismatchTolerance;
	int m_MismatchPercentage;
	bool m_bBriefReport;
};
