// UiThread.cpp : implementation file
//

#include "stdafx.h"
#include <afxinet.h>
#include <sys/stat.h>
#include <locale.h>
#include "WCopyfind.h"
#include "zlib\zlib.h"
#include "zlib\zconf.h"
#include "zlib\unzip.h"
#include "InputDocument.h"
#include "Words.h"
#include "CompareDocuments.h"
#include "UiThread.h"
#include "WCopyfindDlg.h"


// CUiThread

IMPLEMENT_DYNCREATE(CUiThread, CWinThread)

CUiThread::CUiThread()
{
}

CUiThread::~CUiThread()
{
}

BOOL CUiThread::InitInstance()
{
	// TODO:  perform and per-thread initialization here
	return TRUE;
}

int CUiThread::ExitInstance()
{
	// TODO:  perform any per-thread cleanup here
	return CWinThread::ExitInstance();
}

BEGIN_MESSAGE_MAP(CUiThread, CWinThread)
	ON_THREAD_MESSAGE(WU_UITHREAD_START, OnStart)
	ON_THREAD_MESSAGE(WU_UITHREAD_TERMINATE, OnTerminate)
END_MESSAGE_MAP()


// CUiThread message handlers

void CUiThread::OnStart(WPARAM, LPARAM lp)
{
	thread_args* pargs = (thread_args*)lp;
	extern bool g_abort;
	CWCopyfindDlg *pDialog = (CWCopyfindDlg*)pargs->pDialog;

	CString szfolder;

	pDialog->m_Edit_Folder.GetWindowText(szfolder);
	struct _stat buf;
	int result = _tstat( szfolder, &buf );
	if( (result != 0) || ((buf.st_mode & _S_IFDIR) != _S_IFDIR))
	{
		CString szdirerr;
		szdirerr.Format(L"%s%s%s","Report Folder \"",szfolder,"\" cannot be found.");
		AfxMessageBox(szdirerr);
		return;
	}
	
	CCompareDocuments* pdoc;
	int docs = pDialog->m_List_Old.GetItemCount() + pDialog->m_List_New.GetItemCount();

	if( (pdoc = new CCompareDocuments(docs)) == NULL )
	{
		AfxMessageBox(L"Could not allocate enough memory for the documents.");
		if(pdoc != NULL) {delete pdoc; pdoc=NULL;}
		return;
	}

	int fcount;
	int firstNewDoc = pDialog->m_List_Old.GetItemCount();

	for(fcount=0;fcount<pDialog->m_List_Old.GetItemCount();fcount++) wcscpy_s((pdoc->m_pDocs+fcount)->m_DocumentName,256,pDialog->m_List_Old.GetItemText(fcount,0));
	for(fcount=0;fcount<pDialog->m_List_New.GetItemCount();fcount++) wcscpy_s((pdoc->m_pDocs+firstNewDoc+fcount)->m_DocumentName,256,pDialog->m_List_New.GetItemText(fcount,0));
	pdoc->m_FirstNewDocument = firstNewDoc + 1;

	CString szstring;
	pDialog->m_Edit_Phrase.GetWindowText(szstring);
	pdoc->m_PhraseLength = _wtoi(szstring);
	pDialog->m_Edit_Threshold.GetWindowText(szstring);
	pdoc->m_WordThreshold=_wtoi(szstring);
	pDialog->m_Edit_Skip_Length.GetWindowText(szstring);
	pdoc->m_SkipLength=_wtoi(szstring);
	pDialog->m_Edit_Tolerance.GetWindowText(szstring);
	pdoc->m_MismatchTolerance=_wtoi(szstring);
	pDialog->m_Edit_Percentage.GetWindowText(szstring);
	pdoc->m_MismatchPercentage=_wtoi(szstring);

	pDialog->m_Static_Status.ShowWindow(SW_SHOW);
	pDialog->m_Progress.ShowWindow(SW_SHOW);
	
	pdoc->m_bBriefReport = (pDialog->m_Check_Brief_Report.GetCheck() == TRUE);
	pdoc->m_bIgnoreCase = (pDialog->m_Check_Ignore_Case.GetCheck() == TRUE);
	pdoc->m_bIgnoreNumbers = (pDialog->m_Check_Ignore_Numbers.GetCheck() == TRUE);
	pdoc->m_bIgnoreOuterPunctuation = (pDialog->m_Check_Ignore_Outer_Punctuation.GetCheck() == TRUE);
	pdoc->m_bIgnorePunctuation = (pDialog->m_Check_Ignore_Punctuation.GetCheck() == TRUE);
	pdoc->m_bSkipLongWords = (pDialog->m_Check_Skip_Long_Words.GetCheck() == TRUE);
	pdoc->m_bSkipNonwords = (pDialog->m_Check_Skip_Nonwords.GetCheck() == TRUE);

	pdoc->m_szFolder = &szfolder;
	pdoc->m_pReport = &pDialog->m_List_Report;
	pdoc->m_pStatus = &pDialog->m_Static_Status;
	pdoc->m_pProgress = &pDialog->m_Progress;

	pDialog->m_Combo_Language.GetWindowTextW(szstring);
	_wsetlocale(LC_ALL, szstring);

	pdoc->CompareDocuments();

	pDialog->m_Progress.ShowWindow(SW_HIDE);

	if (pdoc != NULL) delete pdoc;

	pDialog->m_Edit_Folder.GetWindowText(szfolder);
	CString szbrowser;
	szbrowser.Format(L"%s%s",szfolder,L"\\matches.html");

	HINSTANCE hinst1 = ShellExecute(NULL, // no parent hwnd
        NULL, // open
        szbrowser, // file name
        NULL, // no parameters
        NULL, // no directory name
        SW_SHOWNORMAL); // yes, show it

	CWnd::FromHandle(pargs->hWnd)->PostMessage(WU_UITHREAD_TERMINATED,1,1);
}
void CUiThread::OnTerminate(WPARAM, LPARAM lp)
{
	extern bool g_abort;
	if(g_abort) PostQuitMessage(1);
	else PostQuitMessage(0);
}